<?php

namespace App\Nova;

use App\Models\Article;
use Ebess\AdvancedNovaMediaLibrary\Fields\Media;
use Illuminate\Http\Request;
use Laravel\Nova\Fields\Boolean;
use Laravel\Nova\Fields\ID;
use Laravel\Nova\Fields\Image;
use Laravel\Nova\Fields\Select;
use Laravel\Nova\Fields\Text;
use Laravel\Nova\Fields\Slug;
use Laravel\Nova\Fields\Trix;
use Laravel\Nova\Http\Requests\NovaRequest;
use Outl1ne\NovaSimpleRepeatable\SimpleRepeatable;
use SadekD\NovaOpeningHoursField\NovaOpeningHoursField;

class Hosea extends Resource
{
    /**
     * The model the resource corresponds to.
     *
     * @var class-string<\App\Models\Hosea>
     */
    public static $model = \App\Models\Hosea::class;

    /**
     * The single value that should be used to represent the resource when being displayed.
     *
     * @var string
     */
    public static $title = 'id';

    /**
     * The columns that should be searched.
     *
     * @var array
     */
    public static $search = [
        'id',
        'name'
    ];

    /**
     * Get the fields displayed by the resource.
     *
     * @param  \Laravel\Nova\Http\Requests\NovaRequest  $request
     * @return array
     */
    public function fields(NovaRequest $request)
    {
        return [
            ID::make()->sortable(),
            Text::make("Store Name")
                ->rules(["required"])
                ->sortable(),
            Slug::make('Slug', 'slug')->from('Store Name')->separator('-')->hideFromIndex()->withMeta([
                'extraAttributes' => ['readonly' => true],
            ]),
            Image::make('Thumbnail')->disk('public')->rules('max:2048')->help('Max. 2048kb'),
            Media::make('Image') //media handles videos
                ->conversionOnIndexView('thumb')
                ->singleMediaRules('max:5000') // max 5000kb
                ->hideFromIndex()
                ->help('Max. 5000kb'),
            Select::make('City')->options(\App\Models\City::all()->pluck('city_name', 'city_name'))
                ->displayUsingLabels(),
            // NovaOpeningHoursField::make(__('Opening Hours'), 'opening_hours')
            //     ->allowExceptions(FALSE),
            // Text::make("Open Day", "open_day")
            //     ->sortable()->rules(["required"]),
            Text::make('Google Maps Links', 'maps_links')->placeholder('https://www.google.com/maps')->sortable()->rules(["required"])->hideFromIndex(),
            Text::make('Address', 'maps')
                ->sortable()
                ->sortable()->rules(["required"]),
            Boolean::make('Event on Going?', 'event'),
            SimpleRepeatable::make('Related Article', 'related_article', [
                Select::make('Related Article')->options(Article::all()->pluck('title', 'id')),
            ]),
        ];
    }

    /*public static function authorizedToCreate(Request $request)
    {
        return false;
    }

    public function authorizedToDelete(Request $request)
    {
        return false;
    }

    public function authorizedToReplicate(Request $request)
    {
        return false;
    }*/

    /**
     * Get the cards available for the request.
     *
     * @param  \Laravel\Nova\Http\Requests\NovaRequest  $request
     * @return array
     */
    public function cards(NovaRequest $request)
    {
        return [];
    }

    public static function label()
    {
        return 'Hosea';
    }

    public static function singularLabel()
    {
        return 'Hosea';
    }

    /**
     * Get the filters available for the resource.
     *
     * @param  \Laravel\Nova\Http\Requests\NovaRequest  $request
     * @return array
     */
    public function filters(NovaRequest $request)
    {
        return [];
    }

    /**
     * Get the lenses available for the resource.
     *
     * @param  \Laravel\Nova\Http\Requests\NovaRequest  $request
     * @return array
     */
    public function lenses(NovaRequest $request)
    {
        return [];
    }

    /**
     * Get the actions available for the resource.
     *
     * @param  \Laravel\Nova\Http\Requests\NovaRequest  $request
     * @return array
     */
    public function actions(NovaRequest $request)
    {
        return [];
    }
}